;===============================================================
;  MSX STAR SOLDIER
;
;	敵等表示
;
;===============================================================
org 	#8cd5


proc
		ld	hl,0xcf15	; 現在の対象
		ld	d,0				;
		ld	e,(hl)			;

_8cdb:
		LD A,(0xcdd6)
		CP 0x1f
		JP nc,_8d64		; スプライトが一杯、終了へ

		ld	h,#c0		; a=[c000+[cddb]]
		ld	l,e				;
		LD A,(HL)			;
		OR A				;
		jp z,_8d52		; 空っぽ、次へ
		CP 0x22				;
		JR z,_8d52		; 0x22も、次へ

		ld	a,l			; y座標テーブル
		add	a,#30			;
		ld	l,a				;
		LD A,(HL)			;
		SUB 0x18			;
		CP 0xc0			; 画面外なら、次へ
		JR nc,_8d52			;
		ld ixl,a		; y座標

		ld	a,l			; x座標テーブル
		sub	#18				;
		ld	l,a				;
		LD A,(HL)			;
		ld ixh,a		; x座標

		ld	l,e			; キャラ種別
		LD A,(HL)			;

		cp	#23			; ボスの砲台
		jr	z,_fixed_spr
		ld	hl,(putsprite+1)
		ld	(putsprite_enemy+1),hl
		or	1
		cp	#1f			; #1e,#1f
		jr	nz,_8d29
_8d12: 
		LD HL,0xc198	; パターン番号=パターン番号テーブル[キャラ番号>>4]
		ADD HL,DE			;
		LD A,(HL)			;
		if 0
				rrca				;
				rrca				;
				rrca				;
				rrca				;
				and	#f				;
				LD C,A				;
				LD B,0				;
				LD HL,_8d6b		; db #00, #10, #20, #30, #08, #18, #28, #38, #40, #50, #60, #70, #48, #58, #68, #78
				ADD HL,BC			;
				JR _8d2e			;
		endif
		; 00,10,20〜e0,f0　→　#00, #10, #20, #30, #08, #18, #28, #38, #40, #50, #60, #70, #48, #58, #68, #78
		ld		l,0
		or		a
		jp		p,_ck_1f1e_sprno
		set		6,l
	_ck_1f1e_sprno:
		bit		6,a
		jr		z,_set_1f1e_sprno
		set		3,l
	_set_1f1e_sprno:
		and		#30
		or		l
		jr		_8d2e_2
	_fixed_spr:
		ld	hl,putsprite_fixed
		ld	(putsprite_enemy+1),hl
_8d29: 
		LD HL,0xc198	; パターン番号=キャラ番号
		ADD HL,DE			;
_8d2e: 
		ld	a,(hl)		; パターン番号が
_8d2e_2:
		CP 0xff				;
		JR z,_8d52			; 255なら次へ
		ld iyl,a		; パターン番号

		LD HL,0xc1c8	; 色テーブル
		ADD HL,DE			;
		LD A,(HL)			;
		push	de
		push	ix
		push	af
		rrca			; 上位4bit
		rrca				;
		rrca				;
		rrca				;
		and	#f				;
		ld iyh,a			;
		call	putsprite_enemy	; 仮想SATに1枚書き込み
		ld		a,iyl		; パターンNoをひとつずらす
		add		a,4				;
		ld		iyl,a			;
		pop		af			; 色
		and		15				;
		ld		iyh,a			;
		pop		ix
		call	putsprite_enemy	; 仮想SATに1枚書き込み
		pop		de

_8d52: 
		inc		e
		ld		a,e
		CP 0x18			; 末尾(全24キャラ)なら、対象を先頭に戻す
		JR c,_8d5d			;
		xor		a			;
		ld		e,a			;
_8d5d:
		LD HL,0xcf15	; 対象が最後[cf15]でなければ、ループ先頭へ
		CP (HL)				;
		JP nz,_8cdb			;
_8d64:
		ld	(hl),e		; 次回先頭記憶
		RET

;_8d6b:
;		db	#00, #10, #20, #30, #08, #18, #28, #38, #40, #50, #60, #70, #48, #58, #68, #78
endp
