;===============================================================
;  MSX STAR SOLDIER
;
;	ボス表示
;
;===============================================================
bossL_pn		equ	#da00;#af25
bossL_w			equ	21
bossL_h			equ	13
bossL_n			equ	12
bossS_pn		equ	#da00+bossL_h*bossL_w;#b036
bossS_w			equ	15
bossS_h			equ	7	+1
bossS_n			equ	16



;===============================
;
;===============================
on_pre_boss_scroll:
		call	update_cur_bg_y
		jp		boss_put_bg_1line
val_5c03_in_rom_0158	equ	on_pre_boss_scroll
val_5c03_in_rom_0193	equ	on_pre_boss_scroll


;===============================
; boss bg一行書き込み準備
;===============================
boss_put_setup:
proc
		; 現在のスクロール基準点を記憶
		ld		hl,back_page
		ld		l,(hl)
		inc		l
		ld		a,(hl)
		add		a,23
		ld		(boss_scr_y_org),a

		; ボス絵のソースをセット
		ld		a,(#cde4)
		and		3
		ld		hl,bossL_pn + bossL_w *(bossL_h-1)
		jr		z,_set
		ld		hl,bossS_pn + bossS_w *(bossS_h-1)
	_set:
		ld		(cur_boss_src),hl
		ret
endp
val_41be_in_rom_0182	equ	boss_put_setup
;004181: cd be 41     CALL 0x41be	; BOSS 仮想PCGを並べる


;===============================
; boss bg一行書き込み
;===============================
boss_put_bg_1line:
		call	star_put_boss_1line

		ld		a,(0xce7e)
		cp		#91
		jp		nc, boss_put_bg_1line_put
proc
	;ボスを配置
		ld		hl,(cur_boss_src)
		ld		a,(#cde4)
		and		3
		jp		nz,_small
	;_large:
		ld		de,#c300 + #20*2
		ld		ix,+( bossL_w<<8 )|( 32+1-bossL_w )
		ld		iyl,bossL_n
		ld		a,bossL_pn-bossL_w
		jp		_put
	_small:
		ld		de,#c300 + 1
		ld		ix,+( bossS_w<<8 )|( 32+1-bossS_w )
		ld		iyl,bossS_n
		ld		a,bossS_pn-bossS_w

	_put:
		cp		l
		jr		z,boss_put_bg_1line_put

	_lpY:
		push	hl
		ld		b,ixh
	_lp:
		ld		a,(hl)
		or		a
		jr		z,_nx
		ld		(de),a
	_nx:
		inc		hl
		inc		de
		djnz	_lp

		ld		a,e
		add		a,ixl
		ld		e,a
		jr		nc,_sk
		inc		d
	_sk:
		dec		iyl
		pop		hl
		jr		nz,_lpY

	;_skipsrc:
		ld		a,l
		sub		ixh
		ld		l,a
		jr		nc,_updtsrc
		dec		h
	_updtsrc:
		ld		(cur_boss_src),hl
endp
boss_put_bg_1line_put:
proc
	; vramに転送
		ld		hl,#c300
		ld		de,(cur_bg_adr)
		ld		ixl,#10
	_lp_v:
		call	set_vram_adr_de
		ld		b,#20
		otir
		ld		a,d
		add		a,4
		ld		d,a
		dec		ixl
		jp		nz,_lp_v

		; 次回転送先移動
		jp		update_cur_bg_adr
endp



