;===============================================================
;  MSX STAR SOLDIER
;
;	自機表示
;
;===============================================================
org 	#4932


put_ships:
		call	prepare_disp
proc
		LD		A,(0xc1e1)
		OR		A
		RET		m

		call	put_ship
		ld 		a,(0xce84)		; 自lv<3
		cp		3
		jr		nc,put_shields
		ret
endp


put_ship:
proc
		ld		iy,#0fe0		; 色,パターン
		call	_put

		ld		hl,0xcf1d		; [0xcf1d]++
		inc		(hl)				;
		ld		a,(hl)			; [0xcf1e]=[0xcf1d]&4
		and		4					;
		dec		l					;
		ld		(hl),a				;
		add		a,#e4			; パターン=#e4 + [0xcf1d]&4
		ld		iyl,a				;
		ld		iyh,#07			; 色
	_put:
		ld		hl,(0xcde9)		; yx
		ld		a,h					;
		sub		0x18				;
		ld		ixl,a				;
		ld		a,l					;
		ld		ixh,a				;

		ld		hl,0xcf1f		; 色
		ld		a,(hl)			; 暗黒モードのときは
		or		a					;
		jr		z,_4972				;
		ld		iyh,1				; 黒に
	_4972:
		inc		l
		ld		a,(hl)			; 無敵の間、色をサイクルで変化
		or		a					;
		jp		z,putsprite			; 仮想SATに1枚書き込み
		dec		(hl)			; 無敵タイマ--
		ld		l,#19			; 2 of 4のとき色bit0反転
		ld		a,(hl)				;
		and		3					;
		cp		2					;
		jp		nz,putsprite		; 仮想SATに1枚書き込み
		ld		a,iyh				;
		xor		1					;色xor=1
		ld		iyh,a				;
		jp		putsprite		; 仮想SATに1枚書き込み
endp


put_shields:
proc
					; シールドを仮想SATに
		ld		iyl,#f0			; パターン
		ld		a,(0xcf19)		; 現在シールド位置idx=(サイクルカウンタ/2)&0xe
		srl		a					;
		and		#0e					;
		push	af
		call	_put_shield
		pop		af
		xor		8
	_put_shield:
		ld		e,a
		ld		d,0
		ld		hl,_shield_ofs
		add		hl,de
		ld		de,(0xcde9)
		ld		a,e
		add		a,(hl)
		ld		ixh,a
		inc		l
		ld		a,d
		add		a,(hl)
		sub		0x18
		ld		ixl,a
		ld		iyh,0x0f
		jp		putsprite		; 仮想SATに1枚書き込み

	_shield_ofs:
		db	#f8,#04, #fb,#fb, #04-1,#f8, #0d-2,#fb, #10-2,#04, #0d-2,#0d, #04-1,#10, #fb,#0d	; シールド オフセット
endp
