;===============================================================
;  MSX STAR SOLDIER
;
;	自弾vsBG 当たり判定
;		軽量化
;		(自弾vs敵当たり判定に間借り)
;
;===============================================================
org	#50a2


proc_518e_hitchk_bg:
		ld		a,(#cddd)
		or		a
		jp		z,#548b		; 次キャラへ e-- if(e==0):0x50ae else:ret

	; スプライト座標をmap展開エリア座標(20x15)に
	; y: (spr_y + 8)/16
		ld		a,ixh
		sub		16-8		; map_yが0か12以上の場合、
		cp		192-(16-8)-8	;
		jp		nc,#548b		; 次キャラへ e-- if(e==0):0x50ae else:ret

		add		a,8 +(16-8)
		rrca
		rrca
		rrca
		rrca
		and		#f
		ld		h,a

	; x: (spr_x - 1)/16 *5/4	 値域:0〜19
		ld		a,ixl
		;dec		a
		srl		a
		ld		l,a
		srl		a
		srl		a
		add		a,l
        rrca
        rrca
        rrca
        and		#1f
		ld		l,a

		ld		(#ce74),hl

	;proc_51c7:
	; map展開エリアアドレス取得
	; [0xce76:2]=0xcc9d + ([0xce75]&15)*20 + [0xce74]
		;ld		hl,(#ce74)

		ld		a,h
		ld		b,x20tbl>>8
		add		a,x20tbl
		;jr		nc,_endx20tbl
		;inc		b
		;_endx20tbl:
		ld		c,a
		ld		a,(bc)

		add		a,l
		ld		h,#cc
		add		a,#9d
		ld		l,a
		jr		nc,_set76
		inc		h
	_set76:
		ld		(#ce76),hl
proc_51fc:
proc
	; mapピースごとに分岐
		ld		a,(hl)		; a=mapピース:[map展開エリア + map_y*20 + map_x]
		ld		(#ce7b),a	; [0xce7b]=mapピース
		cp		#21			; if mapピース < 0x21 :
		jr		c,_5214			; 0x5214 へ
		cp		#a8			; if mapピース < 0xa8 :
		jp		c,#548b			; 次キャラへ e-- if(e==0):0x50ae else:ret
		srl		a			; mapピース/8+12
		srl		a				; 
		srl		a				;
		add		a,12			; 0x21〜0x2b
	_5214:
		add		a,a			; mapピース*2
		ld		h,#525d>>8
		add		a,#525d
		ld		l,a
		ld		a,(hl)
		inc		l
		ld		h,(hl)
		ld		l,a
		ld		a,(#ce7b)	; a=mapピース
		jp		(hl)			;
endp

x20tbl:
		db	0,20,40,60,80,100,120,140,160,180,200,220,240



;=======================================
; BGのアドレスを計算
;	(i)#ce74			map x y
;	(i)cur_bg_y			bgのスクロールオフセットy
;	(o)hl				bgのオフセットアドレスと、map x
;=======================================
get_bg_adr_from_ce74:
proc
		ex		af,af'

		ld		hl,(#ce74)		; x,y map pos
		ld		a,(cur_bg_y)
		rrca
		add		a,h
		sub		2
		and		#f
		ld		h,a
		xor		a
		rr		h
		rra
		rr		h
		rra
		add		a,l
		ld		l,a

		ex		af,af'
		ret
endp
;=======================================
; BGのアドレスを計算
;=======================================
get_bg_adr_from_ce74_to_ce7c:
		call	get_bg_adr_from_ce74
		ld		(#ce7c),hl
		ret



;========================================
;	map展開エリアに32x32残骸:0x27書き出し
;========================================
put_dust_map_parts_32x32:
proc
		ld		a,(#ce74)
		cp		19
		ld		a,#27
		ld		hl,(#ce76)
		ld		(hl),a
		inc		hl
		ld		(hl),a
		jr		nc,_on_border
		ld		bc,19
		add		hl,bc
		ld		(hl),a
		inc		hl
		ld		(hl),a
		ret
	_on_border:
		ld		bc,-21
		add		hl,bc
		ld		(hl),a
		ld		bc,20+19
		add		hl,bc
		ld		(hl),a
		ret
endp




;===============================================================
;	mapパーツごとの処理修正
;===============================================================
; BG1個分左にずらして再チェック
proc_52bd:
proc
		jp		p,_normal
		ld		(hl),19
		ld		hl,(#ce76)
		ld		bc,19
		add		hl,bc
		jr		_end
	_normal:
		ld		hl,(#ce76)
		dec		hl
	_end:
		ld		(#ce76),hl
		jp		proc_51fc
endp
val_51c7_in_rom_12be	equ	proc_52bd

; BG1個分上にずらして再チェック
proc_52c4:
		ld		bc,-20
		ld		hl,(#ce76)
		add		hl,bc
		ld		(#ce76),hl
		jp		proc_51fc
val_51c7_in_rom_12c5	equ	proc_52c4

; BG1個分斜め上にずらして再チェック
proc_52ca:
		dec		(hl)
		dec		l
		dec		(hl)
		ld		bc,-21
		jp		p,_normal
		ld		(hl),19
		ld		bc,-1
	_normal:
		ld		hl,(#ce76)
		add		hl,bc
		ld		(#ce76),hl
		jp		proc_51fc
val_35_in_rom_12ca		equ	#c3
val_ec18_in_rom_12cb	equ	proc_52ca


; 目玉の追加クリップ処理
clip_for_medama:
		call	putchr16x16
		pop		hl
		ld		a,(#ce74)
		cp		19
		jr		nc,_on_border
		inc		hl
	_cmn:
		pop		af
		inc		a	; 次のパーツ
		call	putchr16x16
		jp		#547e
	_on_border:
		ld		a,l
		and		#e0
		ld		l,a
		jp		_cmn

;=======================================
;	mapパーツごとの処理修正を適用
;=======================================
val_2a_in_rom_13b5		equ	#cd
val_ce7c_in_rom_13b6	equ	get_bg_adr_from_ce74
val_29_in_rom_13b9		equ	32
val_5666_in_rom_13c2	equ	putchr16x16_plusHalf

val_2a_in_rom_13d4		equ	#cd
val_ce7c_in_rom_13d5	equ	get_bg_adr_from_ce74
val_50_in_rom_13f4		equ	32*2
val_cd_in_rom_13e0		equ	#c3
val_5666_in_rom_13e1	equ	clip_for_medama

val_2a_in_rom_1408		equ	#cd
val_ce7c_in_rom_1409	equ	get_bg_adr_from_ce74
val_5666_in_rom_140c	equ	putchr16x16

val_2a_in_rom_1434		equ	#cd
val_ce7c_in_rom_1435	equ	get_bg_adr_from_ce74
val_5666_in_rom_1438	equ	putchr16x16


;val_2a_in_rom_1501		equ	#cd
;val_ce7c_in_rom_1502	equ	get_bg_adr_from_ce74
;val_5666_in_rom_1505	equ	putchr16x16

;val_2a_in_rom_155e		equ	#cd
;val_ce7c_in_rom_155f	equ	get_bg_adr_from_ce74_to_ce7c
;val_5666_in_rom_1564	equ	putchr16x16
;val_23_in_rom_158c		equ	0
;val_5666_in_rom_1591	equ	putchr16x16
;val_50_in_rom_15b0		equ	32*2
;val_5666_in_rom_15b9	equ	putchr16x16
;val_52_in_rom_15db		equ	32*2+1
;val_5666_in_rom_15e4	equ	putchr16x16
