;===============================================================
;  MSX STAR SOLDIER
;
;	敵弾表示
;
;===============================================================
org 	#8f71


proc
		ld		a,(0xcf16)		; 処理先頭インデックス
		ld		c,a					;
		ld		b,4				; 最大4枚割当
		ld		iyl,0xf4		; パターン
	_loop:
		ld		e,c
		ld		d,0
		ld		hl,0xc262		; 空きチェック
		add		hl,de				;
		ld		a,(hl)				;
		or		a					;
		jr		z,_next				; 空きなら次へ
		ld		e,8				; x
		add		hl,de				;
		ld		a,(hl)				;
		ld		ixh,a				;
		add		hl,de			; y
		ld		a,(hl)				;
		sub		0x18				;
		ld		ixl,a				;
		ld		iyh,0x7			; 色
		push	bc
		call	putsprite		; 仮想SATに1枚書き込み
		pop		bc
		djnz	_next
		ld		a,c			;全4枚消費したら、次処理先頭インデックス記憶して終了
		inc		a				;
		and		7
		ld		(0xcf16),a
		ret
	_next:
		ld		a,c			; 現在インデックス++ mod 8
		inc		a				;
		and		7				;
		ld		c,a				;
		ld		a,(0xcf16)	; 全弾処理完了？
		cp		c				;
		jr		nz,_loop		; 次へ
		ret
endp
