;===============================================================
;  MSX STAR SOLDIER
;
;	コンフィグ関係
;
;===============================================================


;===============================================================
;	コンフィグモード切り替え
;===============================================================
switch_cfg_mode:
val_5cab_in_rom_1c9a	equ	switch_cfg_mode
proc
		; コンフィグへ
		ld		a,#6
		call	#0141
		bit		5,a
		jr		z,_to_cfg
	_key_on_wait:
		call	is_esc
		jr		z,switch_cfg_mode
	_key_off_wait:
		call	is_esc
		jr		nz,_key_off_wait
		cpl
		ret

	_to_cfg:
		ld		ix,menu_mode
		ld		iyl,#05
		call	call_bank_6000
		; 戻り先をキーoffのところまでに変える
		pop		af
		jp		#5c87
endp

is_esc:
proc
		ld		a,#7
		call	#0141
		bit		2,a
		jr		z,_esc
		xor		a
		ret
	_esc:
		ld		a,#1b
		or		a
		ret
endp
val_5cab_in_rom_1c82	equ	is_esc
val_5cab_in_rom_1c94	equ	is_esc


;===============================================================
;	コンフィグモード切り替え　タイトル画面
;===============================================================
switch_cfg_mode_at_title:
val_49f2_in_rom_1a21	equ	switch_cfg_mode_at_title
proc
		; コンフィグへ
		ld		a,#6
		call	#0141
		bit		5,a
		jp		nz,#49f2
		xor		a
		ld		(#ce95),a		; BGM 消す
		ld		ix,menu_mode
		ld		iyl,#05
		call	call_bank_6000
		pop		af				; 戻り先を変える
		jp		#59e8
endp

;===============================================================
;	トラップゾーン処理切り替え
;===============================================================
check_trapzone_mode:
		ld		a,(cfg_trapzone_mode)
		rrca
		ret		c
		; 本来の処理を続行
		ld		a,(#cf17)
		jp		#4bd4 + 3
val_3a_in_rom_0bd4		equ	#c3
val_cf17_in_rom_0bd5	equ	check_trapzone_mode
