;===============================================================
;  MSX STAR SOLDIER
;
;	自弾当たり判定
;
;===============================================================
bkts_buf	equ		#d200
bkts_size	equ		#0200

bkts_sp_sv	equ		#d500-2
bkts_sp_ptr	equ		bkts_sp_sv-2
bkts_sp		equ		bkts_sp_ptr-2	; 最大サイズ：敵の数13*4*2+2


;=================================================
;	自弾当たり判定
;=================================================
val_50ae_in_rom_148d	equ		lp_shot_50ae
val_50a2_in_rom_0373	equ		hitchk_shot
hitchk_shot:
proc
		LD A,(0xce6a)
		OR A
		JR z,_ck
		DEC A
		LD (0xce6a),A
	_ck:
endp
;=================================================
;	バケツバッファで敵を振りわけ
;=================================================
build_hit_bkts:
proc
	; バケツ掃除用スタックに切り替え
		ld		(bkts_sp_sv),sp
		ld		sp,(bkts_sp_ptr)

	; バケツを空に
		ld		c,0
	_lp_del:
		pop		hl
		ld		(hl),c
		ld		a,h
		or		a
		jp		nz,_lp_del
		push	hl				; スタックトップの印:0000をセット

	; バケツに振り分け
	; インデックス前半の敵
		ld		h,bkts_buf>>8
		ld		ix,#c007
		ld		c,10000000b		; 敵のidxをbit位置で
	_lp:							;426*
		; 空、飛ばす
		ld		a,(ix+0)
		or		a
		jr		z,_next
		; 当たり判定なしは飛ばす
		ld		a,(ix+#48)
		cp		#1c
		jr		c,_next

	; get bkt adr
		ld		d,(ix+#30)	; ey
		ld		e,(ix+#18)	; ex
		ld		a,d
		and		#f0
		ld		l,a
		ld		a,e
		and		#f0
		rrca
		rrca
		rrca
		rrca
		or		l
		ld		l,a
	;_put_0:
		ld		a,(hl)
		or		c
		ld		(hl),a
		push	hl			; 次回バケツ掃除用に記憶
	; 他のバケツにまたがるかチェック
		bit		3,e
		jr		z,_ck_y
		bit		3,d
		jr		nz,_put_3
		jr		_put_1
	_ck_y:
		bit		3,d
		jr		nz,_next
	;_put_2:
		ld		a,l
		add		a,#10
		ld		l,a
		push	hl			; 次回バケツ掃除用に記憶
		ld		a,(hl)
		or		c
		ld		(hl),a
		jr		_next
	_put_3:
		inc		l
		push	hl			; 次回バケツ掃除用に記憶
		ld		a,(hl)
		or		c
		ld		(hl),a
		ld		a,l
		add		a,#0f
		ld		l,a
		push	hl			; 次回バケツ掃除用に記憶
		ld		a,(hl)
		or		c
		ld		(hl),a
	_put_1:
		inc		l
		push	hl			; 次回バケツ掃除用に記憶
		ld		a,(hl)
		or		c
		ld		(hl),a
	_next:
		dec		ixl
		srl		c
		jr		nz,_lp

		; インデックス後半の敵
		ld		ixl,12
		ld		c,00010000b
		inc		h
		ld		a,h
		cp		0+(bkts_buf+bkts_size)>>8
		jp		nz,_lp

	; スタック戻す
		ld		(bkts_sp_ptr),sp
		ld		sp,(bkts_sp_sv)
endp
;=================================================
;	ヒットチェック
;=================================================
check_hit_bkts:
		ld		iy,#ce0e
		ld		e,iyl
lp_shot_50ae:
proc
		ld		iyl,e
	_lp_shot2:
		ld		a,(iy-13)		; cdf3 +n
		or		a
		jp		z,_next_shot

	;_get_hit_bits:
		ld		h,bkts_buf>>8

		ld		a,(iy+2)		; ce02 +n	:y
		ld		ixh,a
		ld		e,a
		and		#f0
		ld		l,a
		ld		a,(iy+17)		; ce11 +n	:x
		ld		ixl,a
		ld		d,a
		and		#f0
		rrca
		rrca
		rrca
		rrca
		or		l
		ld		l,a

	;_bkt_0:				;cycle 70,102,128,180	(場合分けしない場合は121だった)
		ld		a,(hl)
		inc		h
		ex		af,af'
		ld		a,(hl)
		dec		h
		ex		af,af'
	; 他のバケツにまたがるかチェック
		bit		3,e
		jr		z,_ck_y
		bit		3,d
		jr		nz,_bkt_3
		jr		_bkt_1
	_ck_y:
		bit		3,d
		jr		nz,_ed_get_hit_bits
	;_bkt_2:
		ld		de,#10
		add		hl,de
		or		(hl)
		inc		h
		ex		af,af'
		or		(hl)
		dec		h
		ex		af,af'
		jr		_ed_get_hit_bits
	_bkt_3:
		inc		l
		or		(hl)
		inc		h
		ex		af,af'
		or		(hl)
		dec		h
		ex		af,af'
		ld		de,#0f
		add		hl,de
		or		(hl)
		inc		h
		ex		af,af'
		or		(hl)
		dec		h
		ex		af,af'
	_bkt_1:
		inc		l
		or		(hl)
		inc		h
		ex		af,af'
		or		(hl)
		ex		af,af'
	_ed_get_hit_bits:

		ld		c,a
		ex		af,af'
		ld		b,a
		ld		hl,#c018-1
		ld		de,#c030-1

	_lp_obj:
		inc		l
		inc		e
		srl		c
		jr		c,_chk_xy
		jr		nz,_lp_obj

		ld		l,#18+8-1
		ld		e,#30+8-1
		ld		c,b
		ld		b,0
		ld		a,c
		or		a
		jr		nz,_lp_obj

	;_ck_ed:
		ld		e,iyl
		jp		proc_518e_hitchk_bg	; BGとの当たり判定をチェックして、次キャラへ e-- if(e==0):0x50ae else:ret

	_chk_xy:
		; xチェック
		ld		a,(hl)
		sub		ixl
		add		a,#c
		cp		#12
		jr		nc,_lp_obj

		; yチェック
		ld		a,(de)
		sub		ixh
		add		a,#c
		cp		#12
		jr		nc,_lp_obj

		; 爆風チェック(今回処理中に増えた分)
		push	hl
		ld		a,l
		add		a,#18
		ld		l,a
		ld		a,(hl)			; #c048+n
		pop		hl
		cp		#1c
		jr		c,_lp_obj

	;_hit:
		; hl:0xc030+x
		ld		ixh,d
		ld		ixl,e
		ld		bc,#50
		add		ix,bc	; #c080
		; 壊せる敵かチェック
		ld		a,(ix-#38)		; #c048+n
		cp		0x1c
		jr		z,_5108			; id == 0x1c は壊せない。弾消して次へ
		
		ld		a,(ix+#58)		; #c0d8+n
		or		a
		jr		z,_513c

		ld		a,(ix+#10)		; #c090+n
		or		a				;  if hp>0:
		jr		z,_5110				;
		dec		(ix+#10)			; hp--
	_5108:							;
		ld		a,2					; SE:2 反射音
		ld		(#ce89),a				;
		jp		_5185				; 自弾消して、次キャラへ e-- if(e==0):0x50ae else:ret

	_5110:
		; hpゼロになった
		ld		a,(ix-#80)	; #c000+n
		push	af			; 種別保持
		cp		#1f
		jr		nz,_5131
		ld		a,(ix+#70)	; #c0f0+n
		or		a
		jr		nz,_5131
		ld		a,6			; メッセージ表示:BONUS 80000: カウンタ=10
		call	#580e			;
		ld		a,12		; SE:12 ボーナス
		ld		(#ce88),A		;
		ld		a,#38		; スコア加算 +800
		call	#57a1			;
	_5131:
		call	#5683	 	; オールクラッシュ？
		jr		_5170		; スコア加算して 自弾消して、次キャラへ e-- if(e==0):0x50ae else:ret

	_513c:
		ld		a,(ix+#10)			; #c090+n hp == 0なら
		or		a						;
		jr		nz,_5176				;
		ld		a,(ix-#80)				; #c000+n	種別保持
		push	af							;
		ld		(ix-#80),#28			; #c000+n = #28
		ld		a,5						; SE:5 爆発音
		ld		(#ce89),a					;
		ld		(ix-#38),#08			; #c048+n = 8
		ld		(ix-#20),#00			; #c060+n = 0
		ld		bc,#100					; ix=c180
		add		ix,bc						;
		ld		(ix+#18),#c0			; #c198 = #c0
		ld		(ix+#30),#c0			; #c1b0 = #c0
		ld		(ix+#48),#fa			; #c1c8 = #fa

	_5170:
		pop		af			; 種別復帰
		call	#5778		; スコア加算 a:敵種別
		jr		_5185		; 自弾消して、次キャラへ e-- if(e==0):0x50ae else:ret

	_5176:
		ld		(ix-#08),a	; #c078 = 現hpをコピー
		ld		a,2			; SE:2 反射音
		ld		(#ce89),a		;

	_5185:
		ld		(iy-13),0	; 自弾消す cdf3 +n

	_next_shot:				; 次弾へ
		dec		iyl
		jp		p, _lp_shot2
		ret
endp

;=================================================
;	バケツ初期化
;=================================================
init_hit_bkts:
proc
		ld		hl,0
		ld		(bkts_sp),hl
		ld		hl,bkts_sp
		ld		(bkts_sp_ptr),hl
		ld		hl,bkts_buf
		ld		de,bkts_buf+1
		ld		bc,bkts_size
		ld		(hl),0
		ldir
		ret
endp
