;==============================================================================
;
; MSX スターソルジャー
;
;	追加のBGMをセット
;
;==============================================================================


;===============================================================
; タイトルBGM
;===============================================================
set_title_bgm_and_call_444c:
		ld		a,13
		ld		(#ce95),a
		jp		#444c						; タイトル画面をPNTに書き込み

val_444c_in_rom_1a10	equ	set_title_bgm_and_call_444c

;===============================================================
; タイトルBGMを止める
;===============================================================
reset_title_bgm_and_jp_4050:
		xor		a
		ld		(#ce95),a
		jp		#4050

val_4050_in_rom_1a5e	equ	reset_title_bgm_and_jp_4050


;===============================================================
; ゲームオーバーBGM
;===============================================================
set_gameover_bgm_and_call_580e:
		call	#580e	; メッセージ表示:GAME OVER : カウンタ=10
		ld		a,12
		ld		(#ce95),a
		ret

val_580e_in_rom_032d	equ	set_gameover_bgm_and_call_580e	;タイトル画面BGM間借り


;　GAME OVER画面の表示を伸ばす
val_64_in_rom_031c	equ	#bc


;===============================================================
; BRAIN ESCAPED BGM
;===============================================================
set_brain_escaped_bgm_and_call_580e:
		call	#580e	; メッセージ表示:GAME OVER : カウンタ=10
		ld		a,11
		ld		(#ce95),a
		ret

val_580e_in_rom_02c6	equ	set_brain_escaped_bgm_and_call_580e	; メッセージ表示:BRAIN ESCAPED : カウンタ=10

;===============================================================
; EXTEND
;===============================================================
set_extend_se_and_call_43ee:
		ld		l,a
		ld		a,(cfg_sound_driver)
		or		a
		jp		z,_ret
		ld		a,13
		ld		(#ce88),a
	_ret:
		ld		a,l
		jp		#43ee	; 残機数文字化 [0xcdd3]= ((残機数-1)mod 10)|0x30
val_43ee_in_rom_03c2	equ	set_extend_se_and_call_43ee


;===============================================================
;　ボスのBGMが消えるけん
;===============================================================
set_boss_bgm:
proc
		ld		hl,#ce95
		ld		a,(hl)
		or		a
		jr		nz,_ret
		ld		(hl),7
	_ret:
		jp		#8fc9		; 元の処理; [0xc282:2]を自lvとステージNoに応じてセット
endp
val_8fc9_in_rom_01a1	equ	set_boss_bgm
val_8fc9_in_rom_01fd	equ	set_boss_bgm


if 0
;===============================================================
;　パワーアップをイントロから流す
;===============================================================
set_power_up_bgm:
		ld		a,9
		ld		(#ce95),a
		ret
val_59a3_in_rom_1098	equ	set_power_up_bgm
endif
