;===============================================================
;  MSX STAR SOLDIER
;
;	スムーススクロール
;
;===============================================================
romadr	#0000
incbin "StarSoldier.rom"
include "StarSoldier-ss-def.asm"
include "StarSoldier-ss-q.asm"


romadr	#0010
org		#4010
		ld		a,bank_rominit
		ld		(bank_sw_4000),a
		nop
		jp		#401d


if 0	;無敵
	val_20_in_rom_0fdc	equ	#18
	val_28_in_rom_0ff6	equ	#18
endif


romadr	#01be
include "StarSoldier-ss-001be.asm"			; ボスPCG配置
include	"StarSoldier-ss-set_vram_adr.asm"
filler	#01fc

romadr	#0410
include "StarSoldier-ss-00410.asm"			; ボスのフェード色を4ブロック目も更新
filler	#0424

romadr	#04ff
org		#44ff
		ret									; ボス戦用の画面更新やめる
include	"StarSoldier-ss-blt_to_vram.asm"
filler	#0522

romadr	#04bb
include "StarSoldier-ss-004bb.asm"			; ボスPCG書き込み
filler	#04e7

romadr	#0773								; スロット設定削除
org		#4773
filler	#0781

romadr	#07a5
org		#47a5								; HTIMI削除
		ret
filler	#07b1

romadr	#0846
include "StarSoldier-ss-00846.asm"			; 基本PCG書き込み
include	"StarSoldier-ss-fill_vram.asm"
include	"StarSoldier-ss-cfg_proc.asm"
;filler	#08a0
;filler	#08c9
filler	#08ea


romadr	#0932
include "StarSoldier-ss-00932.asm"			; 自機表示
filler	#09f2

romadr	#0a78
include "StarSoldier-ss-00a78.asm"			; 自機爆発スプライト位置修正
filler	#0abd

romadr	#0c80
include "StarSoldier-ss-00c80.asm"			; 自弾移動
filler	#0ccd

romadr	#0f3e
include "StarSoldier-ss-00f3e.asm"			; 自弾表示
filler	#0f6b

romadr	#10a2
include "StarSoldier-ss-010a2.asm"			; 自弾vsBG 当たり判定
filler	#122f

romadr	#1490
include "StarSoldier-ss-01490.asm"			; BG爆発処理
;filler	#1683
;romadr	#1666
;org		#5666
filler	#1683

romadr	#171b
include "StarSoldier-ss-0171b.asm"			; 当たり判定
filler	#1755

romadr	#180e
include "StarSoldier-ss-0180e.asm"			; メッセージ表示処理
filler	#19a3

romadr	#1a60
include "StarSoldier-ss-01a60.asm"			; タイトル配置
DecompressLZSA_to_d600:
		ld		de,#d600
DecompressLZSA:
		include	"StarSoldier-ss-unlzsa1_small.asm"
title_lzsa:
		incbin "StarSoldier-ss-title2.lzsa"
include "StarSoldier-ss-01b8c.asm"			; マップ処理
filler	#1c64


romadr	#1cb6
org		#5cb6
include "StarSoldier-ss-01cca.asm"			; マップ処理
map0_lzsa:
		incbin	"StarSoldier-ss-map0.lzsa"
map1_lzsa:
		incbin	"StarSoldier-ss-map1.lzsa"
map2_lzsa:
		incbin	"StarSoldier-ss-map2.lzsa"
include	"StarSoldier-ss-disp.asm"
include	"StarSoldier-ss-boss_disp.asm"
include	"StarSoldier-ss-star.asm"
include "StarSoldier-ss-set_extra_bgm.asm"
filler	#2cb0


romadr	#30b0
org		#70b0
pcgcol_lzsa:
		incbin "StarSoldier-ss-pcgcol.lzsa"
include	"StarSoldier-ss-hitchk_shot.asm"
filler	#3c96

romadr	#48c9
include "StarSoldier-ss-048c9.asm"			; 爆風のスクロール修正
filler	#4960

romadr	#4cd5
include "StarSoldier-ss-04cd5.asm"			; 敵等表示
filler	#4d91

romadr	#4f71
include "StarSoldier-ss-04f71.asm"			; 敵弾表示
filler	#4fc9

romadr	#6c0c
org		#ac0c
PCGCOLPN_BOSS_LZSA:
		incbin "StarSoldier-ss-pcgcolpn_boss.lzsa"
DecompressLZSA_PCGCOLPN_BOSS:
		ld		(#ce7f),hl
		ld		hl,PCGCOLPN_BOSS_LZSA
		jp		DecompressLZSA_to_d600
val_22_in_rom_00163		equ	#cd
val_ce7f_in_rom_00164	equ DecompressLZSA_PCGCOLPN_BOSS
val_22_in_rom_019dc		equ	#cd
val_ce7f_in_rom_019dd	equ DecompressLZSA_PCGCOLPN_BOSS

include	"StarSoldier-ss-pcg.asm"
filler	#709f



bank_rominit	equ	4
bank_adxif		equ	4
romadr	#8010
org		#4010
include	"StarSoldier-ss-rominit.asm"
include	"StarSoldier-ss-hkey.asm"
include	"StarSoldier-ss-adxif.asm"


bank_menu		equ	5
romadr	#a000
org		#6000
include	"StarSoldier-ss-cfg_menu.asm"


bank_adxdat		equ	6
romadr	#c000
org		#4000
adxdat:			; 曲アドレス,遷移先曲+イントロカウンタ
		dw		ADXDAT_RZRO	,#0000		;未使用
		dw		ADXDAT_RZRO	,#0000		;2
		dw		ADXDAT_CLR	,#0000		;3
		dw		ADXDAT_RZRO	,#0000		;未使用
		dw		ADXDAT_NOML	,#8626		;5
		dw		ADXDAT_NOML	,#0100		;6
		dw		ADXDAT_STBR	,#0000		;7
		dw		ADXDAT_POWU	,#0100		;8
		dw		ADXDAT_POWU	,#8814		;9
		dw		ADXDAT_NULL	,#0000		;未定
		dw		ADXDAT_ESC	,#0000		;11
		dw		ADXDAT_OVER	,#0000		;12
		dw		ADXDAT_TITL	,#0000		;13
ADXDAT_TITL:	incbin	"adx/MUSICDATA/STSLTITL.ADX"
ADXDAT_RZRO:	incbin	"adx/MUSICDATA/STSLRZRO.ADX"
ADXDAT_CLR:		incbin	"adx/MUSICDATA/STSLCLR.ADX"
ADXDAT_OVER:	incbin	"adx/MUSICDATA/STSLOVER.ADX"
ADXDAT_NOML:	incbin	"adx/MUSICDATA/STSLNOML.ADX"
ADXDAT_STBR:	incbin	"adx/MUSICDATA/STSLSTBR.ADX"
ADXDAT_POWU:	incbin	"adx/MUSICDATA/STSLPOWU.ADX"
ADXDAT_ESC:		incbin	"adx/MUSICDATA/STSLESC.ADX"
ADXDAT_NULL:	incbin	"adx/MUSICDATA/STSLMISS.ADX"


bank_mapfc		equ	8
romadr	0x10000
org		#A000
mapfc0_lzsa:	incbin	"StarSoldier-ss-mapfc0.lzsa"
mapfc1_lzsa:	incbin	"StarSoldier-ss-mapfc1.lzsa"
mapfc2_lzsa:	incbin	"StarSoldier-ss-mapfc2.lzsa"
mapfc3_lzsa:	incbin	"StarSoldier-ss-mapfc3.lzsa"
mapfc4_lzsa:	incbin	"StarSoldier-ss-mapfc4.lzsa"
mapfc5_lzsa:	incbin	"StarSoldier-ss-mapfc5.lzsa"
mapfc6_lzsa:	incbin	"StarSoldier-ss-mapfc6.lzsa"
mapfc7_lzsa:	incbin	"StarSoldier-ss-mapfc7.lzsa"
mapfc8_lzsa:	incbin	"StarSoldier-ss-mapfc8.lzsa"




romadr	0x1ffff
		nop
